#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sched.h>

void affiche_infopriorite(void)
{
   printf("\tOrdonnancement SCHED_FIFO  : %d <= priorite <= %d\n",
         sched_get_priority_min (SCHED_FIFO),
         sched_get_priority_max (SCHED_FIFO));
   printf("\tOrdonnancement SCHED_RR    : %d <= priorite <= %d\n",
         sched_get_priority_min (SCHED_RR),
         sched_get_priority_max (SCHED_RR));
   printf("\tOrdonnancement SCHED_OTHER : %d <= priorite <= %d\n",
         sched_get_priority_min (SCHED_OTHER),
         sched_get_priority_max (SCHED_OTHER));
   printf("\n");
}

void affiche_ordonnancement(void) 
{
   struct sched_param schedparam;
   int ordonnancement;
   struct timespec quantum;

   ordonnancement = sched_getscheduler(0);
   if(ordonnancement < 0)
   {
      perror ("sched_getscheduler");
      exit (1);
   }
   if (sched_getparam(0, &schedparam) < 0) 
   {
      perror ("sched_getparam");
      exit (1);
   }
   switch (ordonnancement) 
   {
      case SCHED_FIFO: printf("\tOrdonnancement SCHED_FIFO : \n");
         printf("\t\tPriorité   = %d (sched_priority)\n", schedparam.sched_priority);
         break;
      case SCHED_OTHER: printf("\tOrdonnancement SCHED_OTHER :\n");
         printf("\t\tPriorité statique  = %d (sched_priority)\n", schedparam.sched_priority);
         printf("\t\tpriority dynamique = %d (getpriority)\n", getpriority(PRIO_PROCESS, 0));
         break;
      case SCHED_RR: printf("\tOrdonnancement SCHED_RR : \n");
         printf("\t\tPriorité   = %d (sched_priority)\n", schedparam.sched_priority);
         //calcul du rr
         sched_rr_get_interval(0, &quantum);
         printf("\t\tIntervalle = %u.%09u s (rr_interval)\n", (unsigned int)quantum.tv_sec, (unsigned int)quantum.tv_nsec);		
         break;
   }   
   printf("\n");
}

int main(void) 
{
   printf("debut\n");

   printf("\t-> informations sur les priorités des ordonnancements connus\n");
   affiche_infopriorite();
   
   printf("\t-> informations l'ordonnancement de ce processus\n");
   affiche_ordonnancement();

   printf("fin\n");
   exit(0);
}
